image: node:latest

stages:
  - install
  - build
  - stage
  - deploy

variables:
  CHANNEL_ID: "johuet-staging"

install:
  stage: install
  script:
    - npm install
  cache:
    key:
      files:
        - package-lock.json
    paths:
      - node_modules/

build:
  stage: build
  script:
    - npm run build
  needs: ["install"]
  cache:
    key:
      files:
        - package-lock.json
    policy: pull
    paths:
      - node_modules/
  artifacts:
    expire_in: 1 week
    paths:
      - .firebaserc
      - build
      - firebase.json

deploy:staging:
  image: andreysenov/firebase-tools:latest
  stage: stage
  before_script:
    - firebase use $REACT_APP_PROJECT_ID
  script:
    - firebase hosting:channel:deploy $CHANNEL_ID
        --token $FIREBASE_TOKEN
  needs: ["build"]
  only:
    - master

deploy:production:
  image: andreysenov/firebase-tools:latest
  stage: deploy
  before_script:
    - firebase use $REACT_APP_PROJECT_ID
  script:
    - firebase deploy
        --token $FIREBASE_TOKEN
        --message "Pipeline $CI_PIPELINE_ID, build $CI_BUILD_ID"
        --non-interactive
        --only hosting
  needs: ["build"]
  only:
    - master
  when: manual
